#include "asm86.h"
#include "ti86asm.inc"

_load_ram_ahl	equ		$462F	;Converts ahl to ASIC, loads RAM page.

_dispahl		equ		$4a33	;Displays ahl in decimal.

_runoff			equ		$4AB1	;Disable run indicator.

_runon			equ		$4AAD	;Enable run indicator.

_off			equ		$4101	;Turn off calc.

_getcode		equ		$4068	;Get scancode, but 1000's of clocks faster than GET_KEY.

_exec_basic		equ		$4C57	;Execute TI-BASIC program in OP1.

_exec_asm		equ		$5730	;Execute z80 assembly program in OP1.

_PrevVar		equ		$514F
_NextVar		equ		$514B
_load_ram_ahl	equ		$462F	;Converts ahl to ASIC, loads RAM page.

_pop_op1		equ		$47B7	;Pops OP1 from the FP stack.

_push_op1		equ		$4813	;Pushes OP1 onto the FP stack.

_FindAlphaUp	equ		$514B
_ldhlind        equ		$4010


#define		TotalVars			ProgEnd
#define		PointerPos  		ProgEnd+2
#define		Pointer2VAT 		ProgEnd+4
#define		Pointer2AVAT		ProgEnd+6
#define		AVAT				ProgEnd+8

.org _asm_exec_ram

ScreenSetup:
	call	_clrScrn
	call	_runoff
	call	DoLines
	call	DoTopBar

	ld		de,$0701
	ld		hl,Folder1
	call	DispIt

	ld		de,$0D01
	ld		hl,Folder2
	call	DispIt

	ld		de,$1301
	ld		hl,Folder3
	call	DispIt

	ld		de,$1901
	ld		hl,Folder4
	call	DispIt

	ld		de,$1F01
	ld		hl,Folder5
	call	DispIt

	ld		de,$2501
	ld		hl,Folder6
	call	DispIt

	ld		de,$2B01
	ld		hl,Folder7
	call	DispIt

	ld		de,$3101
	ld		hl,Recycle
	call	DispIt
	call	InvertSelector
	jp		InitVarStuff

GetLoop1:
	call	_getcode
	cp		K_UP
	jp		z,MoveUp
	cp		K_DOWN
	jp		z,MoveDown
	cp		K_SECOND
	jp		z,InitVarStuff
	cp		K_RIGHT
	jp		z,InitVarStuff
	cp		K_EXIT
	jp		z,Exit
	cp		K_PLUS
	call	z,ContrastUp
	cp		K_MINUS
	call	z,ContrastDn
	jr		GetLoop1

MoveUp:
	ld      a,(Posl)
	push	af
	call    InvertSelector
	pop		af
	cp      1
	call	z,HopBarDown
	dec     a
	ld		(Posl),a
	call    InvertSelector
	ld		a,(Posl)
	call	ClearProgPlace
	jp		GetLoop1

HopBarDown:
	ld		a,9
	ret

MoveDown:
	ld      a,(Posl)
	push	af
	call    InvertSelector
	pop		af
	cp		8
	call	z,HopBarUp
	inc		a
	ld		(Posl),a
	call    InvertSelector
	call	ClearProgPlace
	jp		GetLoop1

HopBarUp:
	ld		a,0
	ret

;##############################
;# Variable Selector Routines #
;##############################

InitVarStuff:
	ld		a,(Posl)
	dec		a
	ld		(CurFolder),a
	ld		a,1
	ld		(CurVar),a
	call	FindVars
	ld		a,(TotalVars)
	cp		0
	jp		z,DispNoProgs
	ld		a,1
	ld		(CurVar),a
	call	DispProgs
	ld		a,1

	ld		(Posr),a

	ld		(CurVar),a
	call	UpdateCurProg
	call	Move12b
	set		3,(iy+5)
	call	DisplayHandler
	call	Get_Size
	res		3,(iy+5)

GetLoop2:
	call	_getcode
	cp		K_UP
	jp		z,ProgUp
	cp		K_DOWN
	jp		z,ProgDown
	cp		K_SECOND
	jp		z,ExecProg
	cp		K_DEL
	jp		z,Move2Recycle
	cp		K_XVAR
	jp		z,MoveProg
	cp		K_PLUS
	call	z,ContrastUp
	cp		K_MINUS
	call	z,ContrastDn
	cp		K_LEFT
	jp		z,ProgLeft
	cp		K_RIGHT
	jp		z,ProgRight
	cp		K_EXIT
	jp		z,Back2Folders
	jr		GetLoop2

ProgLeft:
	ld      a,(Posr)

	sub		9
	jp		c,GetLoop2
	call	DisplayHandler

	ld		a,(Posr)
	sub		8
	ld		(Posr),a
	ld		a,(CurVar)
	sub		8
	ld		(CurVar),a
	call	UpdateCurProg
	call	Move12b
	jp		DisplayProg

ProgRight:
	ld      a,(Posr)

	sub		9
	jp		nc,GetLoop2
	ld		a,(CurVar)
	add		a,8
	ld		b,a
	ld		a,(TotalVars)
	sub		b
	jp		c,GetLoop2
	call	DisplayHandler

	ld		a,(Posr)
	add		a,8
	ld		(Posr),a
	ld		a,(CurVar)
	add		a,8
	ld		(CurVar),a
	call	UpdateCurProg
	call	Move12b
	jp		DisplayProg

ProgUp:
	ld		a,(CurVar)
	cp		1
	jp		z,GetLoop2
	call	DisplayHandler

	ld		a,(CurVar)
	dec		a
	ld		(CurVar),a
	call	UpdateCurProg
	call	Move12b
	ld      a,(Posr)

	cp      1

	jr    	nz,SkipPageUp
	ld		a,(CurVar)
	sub		15
	ld		(CurVar),a
	call	DispProgs
	ld		a,17
SkipPageUp:
	dec     a
	ld		(Posr),a

	jp		DisplayProg



ProgDown:
	ld		a,(CurVar)
	ld		hl,TotalVars
	cp		(hl)
	jp		z,GetLoop2
	call	DisplayHandler
	ld		a,(CurVar)
	inc		a
	ld		(CurVar),a
	call	UpdateCurProg
	call	Move12b	

	ld		a,(Posr)
	cp		16
	jr		nz,SkipPageDown
	ld		a,(CurVar)
	push	af
	call	DispProgs
	pop		af
	ld		(CurVar),a
	call	UpdateCurProg
	call	Move12b
	ld		a,0
SkipPageDown:
	inc		a
	ld		(Posr),a
DisplayProg:
	set		3,(iy+5)
	call	DisplayHandler

	res		1,(iy+5)
	call	Get_Size
	jp		GetLoop2


Back2Folders:
	call	ClearProgPlace
	ld		hl,$005C
	ld		(_penCol),hl
	set		3,(iy+5)
	ld		b,35
ClearSize:
	ld		a,' '
	call	_vputmap
	djnz	ClearSize
	res		3,(iy+5)
	call	ClearDescriptPlace
	jp		GetLoop1

DispNoProgs:
	ld		hl,$1B33
	ld		(_penCol),hl
	ld		hl,NoProgs_Str
	call	_vputs
	jp		GetLoop1
	
ExecProg:
	call	_push_op1
	call	SaveVars
	call	_pop_op1
	rst 	10h

	ld		a,b

	ex		de,hl

	call	_load_ram_ahl

	inc		hl

	inc		hl

	xor		a

	cp		(hl)

	jr		z,CheckHex

	inc		hl

	ld		a,(hl)

	cp		$27					;tokenized hex

	jr		z,ExecAsm

	cp		$29					;protected basic

	jr		z,ExecBasic

	cp		$28					;assembly

	jr		z,ExecAsm

CheckHex:
	inc		hl

	ld		a,(hl)
	cp		'A'
	jr		nz,ExecBasic
	inc		hl

	ld		a,(hl)
	cp		's'
	jr		nz,ExecBasic
	inc		hl

	ld		a,(hl)
	cp		'm'
	jr		nz,ExecBasic
	inc		hl

	ld		a,(hl)

	cp		'P'

	jr		z,ExecAsm

ExecBasic:
	call	_runon

	call	_exec_basic

	jp		ScreenSetup

ExecAsm:
	call	_exec_asm

	jp		ScreenSetup


MoveProg:
	ld		a,1
	ld		(PointerPos),a
	call	PlaceArrow

GetLoop3:
	call	_getcode
	cp		K_UP
	jr		z,MovePointerUp
	cp		K_DOWN
	jr		z,MovePointerDn
	cp		K_SECOND
	jp		z,Move2Folder
	cp		K_EXIT
	jr		nz,GetLoop3
	ld		a,(PointerPos)
	call	EraseArrow
	jp		GetLoop2

MovePointerUp:
	call	EraseArrow
	ld		a,(PointerPos)
	cp		1
	call	z,HopPointerDown
	dec		a
	ld		(PointerPos),a
	call	PlaceArrow
	jr		GetLoop3
HopPointerDown:
	ld		a,9
	ret

MovePointerDn:
	call	EraseArrow
	ld		a,(PointerPos)
	cp		8
	call	z,HopPointerUp
	inc		a
	ld		(PointerPos),a
	call	PlaceArrow
	jr		GetLoop3
HopPointerUp:
	ld		a,0
	ret

EraseArrow:
	call	GetPointerOffset
	ld		hl,Spaces_Str
	call	_vputs
	ret

PlaceArrow:
	call	GetPointerOffset
	ld		a,$CF
	call	_vputmap
	ret

GetPointerOffset:
	ld		a,(PointerPos)
	ld		h,a
	ld		l,6
	call	MUL_HL
	inc		hl
	ld		(_penRow),hl
	ld		a,34
	ld		(_penCol),a
	ret

Move2Recycle:
	ld		a,(CurFolder)
	cp		8
	jp		z,DeleteProg
	ld		a,8
	jr		MoveIt

Move2Folder:
	ld		a,(PointerPos)
	push	af
	call	EraseArrow
	pop		af
	dec		a
	
MoveIt:
	push	af
	rst		10h
	ld		de,-4
	add		hl,de
	pop		af
	ld		(hl),a
	call	ClearProgPlace
	call	ClearDescriptPlace
	jp		InitVarStuff
	
DeleteProg:
	rst		10h
	call	nc,_delvar
	call	ClearProgPlace
	call	ClearDescriptPlace
	jp		InitVarStuff

Get_Size:
	call	_push_op1
	rst		10h
	ld		a,b
	ex		de,hl
	call	_load_ram_ahl	
	in		a,(6)
	out		(5),a
	inc		a
	out		(6),a
	ld		de,-$4000
	add		hl,de
	ld		a,(hl)
	ld		(_OP2+2),a
	inc		hl
	ld		a,(hl)
	ld		(_OP2+1),a
TypeFind:
	inc		hl
	push	hl						;first type byte
	ld		a,(hl)
	cp		0
	jr		z,Chk_Basic

	inc		hl
	ld		a,(hl)

	cp		$27

	jr		z,HexProg

	cp		$29

	jr		z,ProtectedProg

	cp		$28

	jp		z,AsmProg

	jr		CompiledBasic


Chk_Basic:
	inc		hl

	ld		a,(hl)
	cp		'A'
	jr		nz,UnCompiledBasic
	inc		hl

	ld		a,(hl)
	cp		's'
	jr		nz,UnCompiledBasic
	inc		hl

	ld		a,(hl)
	cp		'm'
	jr		nz,UnCompiledBasic
	inc		hl

	ld		a,(hl)

	cp		'P'

	jr		nz,UnCompiledBasic
HexProg:
	pop		hl
	ld		a,'H'

	ld		(_OP2),a
	jp		RegularMove


UnCompiledBasic:
	ld		a,'B'
	ld		(_OP2),a
	pop		hl
	inc		hl
	ld		a,(hl)
	cp		$3a
	jr		nz,RegularMove+1
	inc		hl
	ld		a,(hl)
	cp		$22
	jr		nz,RegularMove+1
	inc		hl
	ld		de,_OP2+3
CopyBasicDesc:
	ld		a,(hl)
	cp		$22
	jr		z,PutEndingZero
	ld		(de),a
	inc		hl
	inc		de
	jr		CopyBasicDesc
PutEndingZero:
	xor		a
	ld		(de),a
	jp		DisplayInfo

CompiledBasic:
	ld		a,'B'
	ld		(_OP2),a
	pop		hl
	ld		a,(hl)
	cp		$6E
	jr		nz,RegularMove+1
	inc		hl
	ld		a,(hl)
	cp		$2D
	jr		nz,RegularMove+1
	inc		hl
	ld		de,_OP2+3
CopyBasicDesc2:
	ld		a,(hl)
	cp		0
	jr		z,PutEndingZero
	ld		(de),a
	inc		hl
	inc		de
	jr		CopyBasicDesc2

ProtectedProg:
	ld		a,'P'

	ld		(_OP2),a
RegularMove:
	pop		hl
	ld		hl,_OP1+2
	ld		de,_OP2+3
	ld		a,(_OP1+1)
	ld		c,a
	ld		b,0
	ldir
	xor		a
	ld		(de),a
	jp		DisplayInfo
	
AsmProg:
	ld		a,'A'

	ld		(_OP2),a
	pop		hl
	inc		hl
	inc		hl
	ld		a,(hl)
	cp		0

	jr		nz,RegularMove+1

	inc		hl
	ld		a,(hl)
	cp		0
	jr		z,RegularMove+1
	dec		hl
	push	hl				;nop is here

	ld		de,6

	add		hl,de

	ld		e,(hl)

	inc		hl

	ld		d,(hl)

	ex		de,hl

	ld		de,$D748

	sbc		hl,de

	pop		de

	add		hl,de

	ld		de,_OP2+3
	ld		bc,27
	ldir

DisplayInfo:
	ld		a,$0D
	out		(5),a
	ld		a,$41
	out		(6),a
	set		3,(iy+5)
	ld		de,$005C

	ld		(_penCol),de
	ld		hl,SizeStr
	call	_vputs

	ld		a,(_OP2+2)
	ld		l,a
	ld		a,(_OP2+1)
	ld		h,a
	xor		a

	ld		de,-1

	ld		(_curRow),de

	call	_dispahl

	dec		hl

	call	_vputs
	ld		b,13
BustOutSomeSpaces:
	ld		a,' ' 
	call	_vputmap
	djnz	BustOutSomeSpaces
	res		3,(iy+5)
	call	ClearDescriptPlace
	ld		de,$3901

	ld		(_penCol),de
	ld		hl,_OP2+3
	call	_vputs
	ld		de,$3969

	ld		(_penCol),de
	ld		hl,TypeStr
	call	_vputs
	ld		a,(_OP2)
	call	_vputmap
	call	_pop_op1
	ret

DisplayHandler:
	set		1,(iy+5)
	ld		a,(Posr)

	cp		9
	ld		b,38
	push	bc
	jr		c,FirstCol
SecondCol:
	sub		8
	pop		bc
	ld		b,82
	push	bc
FirstCol:
	ld		h,a

	ld		l,6

	call	MUL_HL

	inc		hl
	ld		(_penRow),hl

	pop		bc
	ld		a,b

	ld		(_penCol),a

	ld		hl,Spaces_Str
	call	_vputs
	ld		a,(_OP1+1)
	ld		b,a
	ld		hl,_OP1+2
	call	_vputsn
	ld		hl,Spaces_Str
	call	_vputs
	res		1,(iy+5)
	ret

FindVars:
	ld		hl,0
	ld		(TotalVars),hl
	call	$47F3
	ld		hl,AVAT
	ld		(Pointer2AVAT),hl
	ld		hl,$BFFF
SearchLoop:
	ld 		de,(VAT_END)
	inc 	de
	or 		a
	sbc 	hl,de
	ret		c
	add 	hl,de
	ld 		a,(hl)
	cp		$12
	jr		nz,NotInCurFolder
	ld		de,-4
	add		hl,de
	ld		b,(hl)
	dec		hl
	dec		hl
	ld		c,(hl)
	ld		de,6
	add		hl,de
	ld		a,(CurFolder)
	cp		b
	jr		nz,NotInCurFolder
	ld		a,c
	cp		$10
	jr		z,NotInCurFolder
	cp		'#'
	jr		z,NotInCurFolder
	cp		'!'
	jr		z,NotInCurFolder
	cp		'm'
	jr		nz,ProgFound
	ld		de,-7
	add		hl,de
	ld		a,(hl)
	dec		hl
	ld		b,(hl)		
	ld		de,8
	add		hl,de
	cp		's'
	jr		nz,ProgFound
	ld		a,b
	cp		'e'
	jr		nz,ProgFound

NotInCurFolder:
 	dec 	hl
	dec 	hl
	dec 	hl
	dec 	hl
	dec 	hl
 	ld 		b,(hl)
 	inc 	b
SkipName:
	dec 	hl
	djnz 	SkipName
	jr 		SearchLoop

ProgFound:
	dec 	hl				
	dec 	hl
	dec 	hl
	dec 	hl
	dec 	hl
	ld 		b,(hl)
	ld 		ix,(Pointer2AVAT)
	ld 		a,$12
	ld 		(ix),a
	inc		ix
	ld		a,b
	ld		(ix),a
	inc		ix
SaveName:
	dec 	hl
	ld 		a,(hl)
	ld 		(ix),a
	inc 	ix
	djnz 	SaveName
	ld 		(ix),$0
	dec 	hl
	ld 		(Pointer2VAT),hl
	ld		hl,(Pointer2AVAT)
	ld		de,12
	add		hl,de
	ld		(Pointer2AVAT),hl
	ld		a,(TotalVars)
	inc		a
	ld		(TotalVars),a
	ld		hl,(Pointer2VAT)
	jp		SearchLoop

DispProgs:
	call	ClearProgPlace	
	ld		a,1
	ld		(Posr),a
	call	UpdateCurProg
TheMoveLoop:
	call	Move12b
	call	DisplayHandler
	ld		a,(Posr)
	inc		a
	ld		(Posr),a
	cp		17
	ret		z
	ld		a,(CurVar)
	ld		hl,TotalVars
	cp		(hl)
	ret		z
	inc		a
	ld		(CurVar),a
	call	UpdateCurProg
	jr		TheMoveLoop	

UpdateCurProg:
	ld		a,(CurVar)
	ld		h,a
	ld		l,12
	call	MUL_HL
	ld		de,AVAT-12
	add		hl,de
	ret

Move12b:
	ld		bc,12
	ld		de,_OP1
	ldir
	ret

DrawVLine:
	ld		a,(hl)
	or		c
	ld		(hl),a
	add		hl,de

	djnz	DrawVLine

	ret

DrawHLine:
	ld		a,$FF
	ld		(hl),a

	inc		hl

	djnz	DrawHLine

	ret

ClearProgPlace:
	ld		hl,$FC74
	ld		c,49

	ld		b,12

ClearVars:
	ld		a,0
	ld		(hl),a

	inc		hl

	djnz 	ClearVars

	ld		de,4

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,12
	jr		nz,ClearVars

	call	DoLines
	ret

ClearDescriptPlace:
	ld		hl,$FF90
	ld		b,112
ClearDesc:
	xor		a
	ld		(hl),a
	inc		hl
	djnz	ClearDesc
	ret

DispIt:
	ld		(_penCol),de
	call	_vputs
	ret

InvertSelector:
	ld      a,(Posl)
	ld      h,a
	ld      l,$60
	call    MUL_HL
	ld      de,$FC10
	add     hl,de			
	call    InvertBar
	call	DoLines
	ret

InvertBar:
	ld		c,7

	ld		b,4

Inverter:
	ld		a,(hl)
	cpl
	ld		(hl),a

	inc		hl

	djnz 	Inverter

	ld		de,12

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,4
	jr		nz,Inverter

	ret

DoTopBar:
	ld		de,$0003
	ld		hl,ProgramName
	call	DispIt
	ld		hl,$FC00
	call	InvertFullBar
	ret

DoLines:
	ld		b,49

	ld		hl,$FC70

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ld		b,49

	ld		hl,$FC7F

	ld		c,%00000001

	ld		de,16

	call	DrawVLine
	ld		b,49

	ld		hl,$FC74

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ld		b,16
	ld		hl,$FF80
	call	DrawHLine
	ret

Exit:
	call	SaveVars
	call	_homeup
	jp		_clrScrn

ShutCalcOff:
	res		3,(iy+8)

	set		4,(iy+8)

	call 	_off

	ld		a,$FF
	ret

InvertFullBar:
	ld      b,$70

InvertFullBarLoop:
	ld      a,(hl)

	cpl
	ld      (hl),a

	inc     hl

	djnz	InvertFullBarLoop

	ret

DispHL:
	ld		de,-1

	ld		(_curRow),de

	call	_dispahl

	dec		hl

	call	_vputs

	ret

ContrastDn:
	ld		a,-1

	jr		ContrastMain

ContrastUp:
	ld		a,1

ContrastMain:
	ld		hl,CONTRAST

	add		a,(hl)

	and		$1F

	ld		(hl),a

	out		(2),a

	halt
	halt
	ld		a,$FF
	ret

SaveVars:
	ld		hl,mseVAT
	rst		20h
	rst		10h
	ret		c
	ld		a,b
	ex		de,hl
	call	_load_ram_ahl
	in		a,(6)
	out		(5),a	
	inc		a
	out		(6),a
	ld		de,$4000
	sbc		hl,de
	ld		de,Posl-$D748+4
	add		hl,de
	ld		bc,4
	ex		de,hl
	ld		hl,Posl
	ldir
	ld		a,$0D
	out		(5),a
	ret

ProgramName:
	.db "MSE v3.5",0

mseVAT:
	.db $12,$03,"mse"

Folder1:
	.db "/root",0
Folder2:
	.db "/games",0
Folder3:
	.db "/math",0
Folder4:
	.db "/science",0
Folder5:
	.db "/misc",0
Folder6:
	.db "/libs",0
Folder7:
	.db "/etc",0
Recycle:
	.db "/recycle",0

SizeStr:
	.db "Size:",0

TypeStr:
	.db "Type:",0

Spaces_Str:
	.db "   ",0

NoProgs_Str:
	.db "No Programs",0

Posl:
	.db	1
Posr:
	.db 0
CurVar:
	.db 0
CurFolder:
	.db 0

ProgEnd:

.end
